use core::{cell::RefCell, ops::DerefMut};

use acpi::AcpiHandler;
use alloc::boxed::Box;

use crate::mem::{paging::ActivePageTable, Frame};

#[derive(Debug, Clone)]
struct AcpiMapper {
    apt: RefCell<ActivePageTable>
}

impl AcpiMapper {
    pub fn new(apt: ActivePageTable) -> Self {
        Self {
            apt: RefCell::new(apt)
        }
    }
}



