use x86_64::structures::idt::InterruptStackFrame;

use crate::interrupts::{InterruptIndex, PICS};

pub extern "x86-interrupt" fn timer_interrupt(_: InterruptStackFrame){
    //log::debug!("INT: TIMER\n{:#?}", sf);
    // print!(".");
    // EVENTMAN.lock().dispatch(&crate::events::Event::TimerInterrupt(None));
    unsafe {
        PICS.lock()
            .notify_end_of_interrupt(InterruptIndex::Timer.get());
    }
}

