%define VIDEO_MODE 0

section .data
global __VIDEO_MODE
__VIDEO_MODE: db VIDEO_MODE


section .multiboot_header
header_start:
    dd 0xe85250d6                ; magic number (multiboot 2)
    dd 0                         ; architecture 0 (protected mode i386)
    dd header_end - header_start ; header length
    ; checksum
    dd 0x100000000 - (0xe85250d6 + 0 + (header_end - header_start))

    ; insert optional multiboot tags here

%if VIDEO_MODE
    dw 5 ; type
    dw 1 ; flags
    dd 20 ; size
    dd 0  ; width
    dd 0  ; height
    dd 24  ; depth
    ; grub 2 expects 8 byte alignment
    dw 0 ; padding
    dw 0 ; padding
%endif
    dw 0    ; type
    dw 0    ; flags
    dd 8    ; size
header_end:
