use alloc::{boxed::Box, format, string::String};
use anyhow::bail;

use super::Driver;


#[derive(Debug)]
pub struct Ps2Driver{

}

impl Ps2Driver {
    pub fn test(&self) -> String {
        String::from("hewo")
    }

}

impl Driver for Ps2Driver {
    fn new() -> impl Driver where Self: Sized {
        Self {

        }
    }
    fn register(
            name: &mut alloc::string::String,
            author: &mut alloc::string::String,
            license: &mut alloc::string::String,
        ) -> Box<dyn Driver> where Self: Sized {
        *name = format!("PS/2");
        *author = format!("MCorange <mcorange@mcorangehq.xyz>");
        *license = format!("GPLv3");
        Box::new(Self::new())
    }

    fn startup(&mut self) -> anyhow::Result<()> {
        Ok(()) 
    }

    fn shutdown(&mut self) -> anyhow::Result<()> {
        Ok(())
    }
}
